com.fasterxml.jackson.databind.ser.std

## Class StaticListSerializerBase<T extends java.util.Collection<?>>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.std.StaticListSerializerBase<T>

- All Implemented Interfaces:
    JsonFormatVisitable, SchemaAware, ContextualSerializer, java.io.Serializable
  Direct Known Subclasses:
    IndexedStringListSerializer, StringCollectionSerializer

      public abstract class StaticListSerializerBase<T extends java.util.Collection<?>>
      extends StdSerializer<T>
      implements ContextualSerializer

  Intermediate base class for Lists, Collections and Arrays that contain static (non-dynamic) value types.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `JsonSerializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JsonSerializer<java.lang.String>` | `_serializer`
    `protected java.lang.Boolean` | `_unwrapSingle` Setting for specific local override for "unwrap single element arrays": true for enable unwrapping, false for preventing it, `null` for using global configuration.

    - ### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `_handledType`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `StaticListSerializerBase(java.lang.Class<?> cls)`
    `protected` | `StaticListSerializerBase(StaticListSerializerBase<?> src, JsonSerializer<?> ser, java.lang.Boolean unwrapSingle)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract JsonSerializer<?>` | `_withResolved(BeanProperty prop, JsonSerializer<?> ser, java.lang.Boolean unwrapSingle)`
    `protected abstract void` | `acceptContentVisitor(JsonArrayFormatVisitor visitor)`
    `void` | `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Default implementation specifies no format.
    `protected abstract JsonNode` | `contentSchema()`
    `JsonSerializer<?>` | `createContextual(SerializerProvider serializers, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
    `JsonNode` | `getSchema(SerializerProvider provider, java.lang.reflect.Type typeHint)` Default implementation simply claims type is "string"; usually overriden by custom serializers.
    `boolean` | `isEmpty(SerializerProvider provider, T value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
    `boolean` | `isEmpty(T value)` Deprecated.

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `createObjectNode, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, getSchema, handledType, isDefaultSerializer, serialize, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `getDelegatee, isUnwrappingSerializer, properties, replaceDelegatee, serializeWithType, unwrappingSerializer, usesObjectId, withFilterId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _serializer

          protected final JsonSerializer<java.lang.String> _serializer

    - #### _unwrapSingle

          protected final java.lang.Boolean _unwrapSingle

      Setting for specific local override for "unwrap single element arrays": true for enable unwrapping, false for preventing it, `null` for using global configuration.
      Since:
        2.6

  - ### Constructor Detail

    - #### StaticListSerializerBase

          protected StaticListSerializerBase(java.lang.Class<?> cls)

    - #### StaticListSerializerBase

          protected StaticListSerializerBase(StaticListSerializerBase<?> src,
                                  JsonSerializer<?> ser,
                                  java.lang.Boolean unwrapSingle)

      Since:
        2.6

  - ### Method Detail

    - #### _withResolved

          public abstract JsonSerializer<?> _withResolved(BeanProperty prop,
                                        JsonSerializer<?> ser,
                                        java.lang.Boolean unwrapSingle)

      Since:
        2.6

    - #### createContextual

          public JsonSerializer<?> createContextual(SerializerProvider serializers,
                                           BeanProperty property)
                                             throws JsonMappingException

      Description copied from interface: `ContextualSerializer`
      Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.
      Specified by:
        `createContextual` in interface `ContextualSerializer`
      Parameters:
        `serializers` - Serializer provider to use for accessing config, other serializers
        `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
      Returns:
        Serializer to use for serializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### isEmpty

          @Deprecated
          public boolean isEmpty(T value)

      Deprecated.
      Description copied from class: `JsonSerializer`
      Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

      Default implementation will consider only null values to be empty.

      Overrides:
        `isEmpty` in class `JsonSerializer<T extends java.util.Collection<?>>`

    - #### isEmpty

          public boolean isEmpty(SerializerProvider provider,
                        T value)

      Description copied from class: `JsonSerializer`
      Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

      Default implementation will consider only null values to be empty.

      NOTE: replaces `JsonSerializer.isEmpty(Object)`, which was deprecated in 2.5

      Overrides:
        `isEmpty` in class `JsonSerializer<T extends java.util.Collection<?>>`

    - #### getSchema

          public JsonNode getSchema(SerializerProvider provider,
                           java.lang.reflect.Type typeHint)

      Description copied from class: `StdSerializer`
      Default implementation simply claims type is "string"; usually overriden by custom serializers.
      Specified by:
        `getSchema` in interface `SchemaAware`
      Overrides:
        `getSchema` in class `StdSerializer<T extends java.util.Collection<?>>`
      Parameters:
        `provider` - The serializer provider.
        `typeHint` - A hint about the type.
      Returns:
        Json-schema for this serializer.

    - #### acceptJsonFormatVisitor

          public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                                     JavaType typeHint)
                                       throws JsonMappingException

      Description copied from class: `StdSerializer`
      Default implementation specifies no format. This behavior is usually overriden by custom serializers.
      Specified by:
        `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
      Overrides:
        `acceptJsonFormatVisitor` in class `StdSerializer<T extends java.util.Collection<?>>`
        `typeHint` - Type of element (entity like property) being visited
      Throws:
        `JsonMappingException`

    - #### contentSchema

          protected abstract JsonNode contentSchema()

    - #### acceptContentVisitor

          protected abstract void acceptContentVisitor(JsonArrayFormatVisitor visitor)
                                                throws JsonMappingException

      Throws:
        `JsonMappingException`